public class Polynom {
	//Koeffizienten per default mit
	//0 initialisiert
    private double a = 0;
    private double b = 0;
    private double c = 0;
    private double d = 0;

    public Polynom(double d) {
        this.d = d;
    }

    public Polynom(double c, double d) {
        this.c = c;
        this.d = d;
    }

    public Polynom(double b, double c, double d) {
        this.b = b;
        this.c = c;
        this.d = d;
    }

    public Polynom(double a, double b, double c, double d) {
        this.a = a;
        this.b = b;
        this.c = c;
        this.d = d;
    }

    public Polynom add(Polynom p){
		//Neues Polynom erzeugen - mit den addierten Koeffizienten
		//des aktuellen und bergebenen Polynoms
        return new Polynom(a + p.a, b + p.b, c + p.c, d + p.d);
    }

    public double apply(double x) {
        //Hier wird das Horner Schema angewendet
        return ((a*x + b)*x + c)*x + d;
    }

    public Polynom dx() {
        return new Polynom(0, 3 * a, 2 * b, c);
    }

    public Polynom integral() {
        return new Polynom(b/3, c/2, d, 0);
    }

    public void print() {
		//Boolesche Variable zum Test, ob es sich
		//um den ersten auszudruckenen Koeffizienten handelt.
        boolean firstCoeff = true;

        //Ausdrucken von a und x, falls nicht 0
        if (a != 0) {
            firstCoeff = false;

            //Ausdrucken von a falls auch nicht 1
            if (a != 1) System.out.print(a + "*");

            System.out.print("x^3 ");
        }

        if (b != 0) {
            if (firstCoeff) {
                firstCoeff = false;
                if (b<0) System.out.print("-");
            } else {

				//Falls nicht erster Koeffizient,
				//Additionszeichen einsetzen,
                System.out.print(b > 0? "+ " : "- ");
            }
            if (b != 1) System.out.print(Math.abs(b) + "*");
            System.out.print("x^2 ");
        }

        if (c != 0) {
            if (firstCoeff) {
                firstCoeff = false;
                if (c<0) System.out.print("-");
            } else {
                System.out.print(c > 0? "+ " : "- ");
            }
            if (c != 1) System.out.print(Math.abs(c) + "*");
            System.out.print("x ");
        }

        if (d != 0) {
            if (firstCoeff) {
                firstCoeff = false;
                if (d<0) System.out.print("-");
            } else {
                System.out.print(d > 0? "+ " : "- ");
            }
            System.out.print(Math.abs(d));
        }

        System.out.println();

    }
}
